#include "stdafx.h"
#include <shellapi.h>

#include "MyControl.h"

// *****************************************************************************************

CMyControl::CMyControl(BOOL noTitle)
{
	m_hWndControl = NULL;
	m_hInstance = NULL;
	m_itemHeight = -1;
}


// *****************************************************************************************

void CMyControl::operator=(HWND hWnd)
{
	m_hWndControl = hWnd;
	m_hInstance = (HINSTANCE) GetWindowLong(hWnd,GWL_HINSTANCE);
	sub = hWnd;
	subParent = GetParent();
	m_itemHeight = -1;
	scroll.Init(hWnd);
}


// *****************************************************************************************

CMyControl::~CMyControl()
{
	sub.Delete();
	subParent.Delete();
}

// *****************************************************************************************

HINSTANCE CMyControl::GethInstance()
{
	return (HINSTANCE) GetWindowLong(m_hWndControl,GWL_HINSTANCE);
}

// *****************************************************************************************

BOOL CMyControl::ShowWindow(BOOL isShow)
{
	return ::ShowWindow(m_hWndControl,isShow ? SW_SHOW : SW_HIDE);
}

// *****************************************************************************************

BOOL CMyControl::DestroyWindow()
{
	return ::DestroyWindow(m_hWndControl);
}

// *****************************************************************************************

void CMyControl::DragAcceptFile (BOOL drag)
{ 
	::DragAcceptFiles(m_hWndControl,drag);
}

// *****************************************************************************************

BOOL CMyControl::Enable(BOOL enable)
{
	return EnableWindow(m_hWndControl,enable);
}

// *****************************************************************************************

HWND CMyControl::GetParent()
{
	return ::GetParent(m_hWndControl);
}

// *****************************************************************************************

HWND CMyControl::CreateDialog(long idDialog,DLGPROC callBack,long param)
{
	return ::CreateDialogParam(m_hInstance,MAKEINTRESOURCE(idDialog),m_hWndControl,(DLGPROC) callBack,param);
}

int CMyControl::ModalDialog(long idDialog,DLGPROC callBack,long param)
{
	return DialogBoxParam(m_hInstance,MAKEINTRESOURCE(idDialog),m_hWndControl,(DLGPROC) callBack,param);
}

// *****************************************************************************************

BOOL CMyControl::SetIcon(long idIcon)
{
	return SetClassLong(m_hWndControl,GCL_HICON,(LONG) LoadIcon(m_hInstance,MAKEINTRESOURCE(idIcon))); 
}

// *****************************************************************************************

BOOL CMyControl::GetWindowRect(RECT *rect)
{
	return ::GetWindowRect(m_hWndControl,rect);
}

// *****************************************************************************************

BOOL CMyControl::GetText(MyString &dest,int idChildControl)
{
	HWND hWnd;
	hWnd = idChildControl ? operator[](idChildControl) : m_hWndControl;
	
	int size = GetWindowTextLength(hWnd)+1;
	dest.Resize(size);
	BOOL res = GetWindowText(hWnd,dest,size);
	dest.Resize();
	return res;
}

/* ******************************************************************************************
	MAJ le text soit du titre (si control = dialog)
	soit de la valeur du control (ex pour une static: son text d'affichage)
***************************************************************************************** */

BOOL CMyControl::SetText(char *dest,int idChildControl)
{
	HWND hWnd;
	hWnd = idChildControl ? this[idChildControl] : m_hWndControl;

	if ((GetWindowLong(hWnd,GWL_STYLE) & WS_CHILD)==WS_CHILD)
	{

		SetWindowText(hWnd,"                                                           ");
		::InvalidateRect(hWnd,NULL,FALSE);
		return SetWindowText(hWnd,dest);
	}
	return SetWindowText(hWnd,dest);
}

// *****************************************************************************************

int CMyControl::GetDlgCtrlID()
{
	return ::GetDlgCtrlID(m_hWndControl);
}

// *****************************************************************************************


// *****************************************************************************************

BOOL CMyControl::InvalidateRect(RECT *rect,BOOL erase)
{
	return ::InvalidateRect(m_hWndControl,rect,erase);
}

// *****************************************************************************************

BOOL CMyControl::SetPos(int x,int y,HWND hWndOrigine)
{
	if (hWndOrigine)
	{
		CMyControl control = hWndOrigine;
		int x1,y1;
		control.GetPos(&x1,&y1);
		x+=x1;
		y+=y1;	
	}
	return SetWindowPos(GetHWND(),NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}

// *****************************************************************************************

BOOL CMyControl::SetSize(int dx,int dy)
{
	return SetWindowPos(GetHWND(),NULL,0,0,dx,dy,SWP_NOMOVE|SWP_NOZORDER);
}

// *****************************************************************************************

BOOL CMyControl::GetClientRect(RECT *rect)
{
	return ::GetClientRect(GetHWND(),rect);
}

// *****************************************************************************************

BOOL CMyControl::GetSize(int *dx,int *dy)
{
	CMyRect rect;
	if (!GetClientRect(&rect.r)) return FALSE;
	if (dx) *dx = rect.DeltaX();
	if (dy) *dy = rect.DeltaY();
	return TRUE;
}

// *****************************************************************************************

BOOL CMyControl::GetPos(int *x,int *y)
{
	RECT rect;
	GetWindowRect(&rect);
	POINT pt;
	pt.x = rect.left;
	pt.y = rect.top;
	ScreenToClient(GetParent(),&pt);
	*x=pt.x;
	*y=pt.y;
	return TRUE;
}

// *****************************************************************************************

LRESULT CMyControl::SendMessage(UINT Msg,WPARAM wParam,LPARAM lParam)
{
	return ::SendMessage(GetHWND(),Msg,wParam,lParam);
}

// *****************************************************************************************

void CMyControl::PostMessage(UINT Msg,WPARAM wParam,LPARAM lParam)
{
	::PostMessage(GetHWND(),Msg,wParam,lParam);
}

// *****************************************************************************************

BOOL CMyControl::SetForegroundWindow()
{
	return ::SetForegroundWindow(GetHWND());
}

// *****************************************************************************************

HWND CMyControl::SetActiveWindow()
{
	return ::SetActiveWindow(GetHWND());
}

// *****************************************************************************************

HWND CMyControl::operator [] (int index)
{
	return GetDlgItem(GetHWND(),index);
}

// *****************************************************************************************

DWORD CMyControl::GetStyle()
{
	return GetWindowLong(m_hWndControl,GWL_STYLE);
}

// *****************************************************************************************

DWORD CMyControl::GetStyleEx()
{
	return GetWindowLong(m_hWndControl,GWL_EXSTYLE);
}

// *****************************************************************************************

LONG CMyControl::SetStyle(DWORD dwStyle)
{
	return SetWindowLong(GetHWND(),GWL_STYLE,dwStyle);
}

// *****************************************************************************************

LONG CMyControl::SetStyle(DWORD dwStyle,BOOL set)
{
	LONG result = GetStyle();

	result |=dwStyle;
	if (!set) result-=dwStyle;
	return SetStyle(result);
}

// *****************************************************************************************

LONG CMyControl::SetStyleEx(DWORD dwStyle)
{
	return SetWindowLong(GetHWND(),GWL_EXSTYLE,dwStyle);
}

// *****************************************************************************************

LONG CMyControl::SetStyleEx(DWORD dwStyle,BOOL set)
{
	LONG result = GetStyleEx();
	result |=dwStyle;
	if (!set) result-=dwStyle;
	return SetStyleEx(result);
}

// *****************************************************************************************

BOOL CMyControl::IsToolWindow()
{
	LONG style = GetStyleEx();
	return (style&WS_EX_TOOLWINDOW)?TRUE:FALSE;
}

// *****************************************************************************************

void CMyControl::SetTopMost(BOOL set)
{
	SetWindowPos(GetHWND(),set?HWND_TOPMOST:HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
}

// *****************************************************************************************

int CMyControl::MessageBox(char *text,char *caption,UINT type)
{
	return ::MessageBox(GetHWND(),text,caption,type);
}

// *****************************************************************************************

HMENU CMyControl::GetSystemMenu(BOOL bRevert)
{
	return ::GetSystemMenu(m_hWndControl,bRevert);
}

// *****************************************************************************************

HWND CMyControl::SetCapture()
{
	return ::SetCapture(m_hWndControl);
}

// *****************************************************************************************
// *****************************************************************************************
