#if !defined(AFX_MYCONTROL_H__EC7EC7AD_A9D6_414E_A3B6_66870A1519B1__INCLUDED_)
#define AFX_MYCONTROL_H__EC7EC7AD_A9D6_414E_A3B6_66870A1519B1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#undef CreateDialog // sinon pb

#include "MyScroll.h"
#include "MyString.h"
#include "MyRect.h"
#include "MySubClassing.h"

class CMyControl
{
	protected:
		HWND m_hWndControl;

	private:
		HINSTANCE m_hInstance;
		int	m_itemHeight;
		
	public:
		CMyScroll scroll;
		CMySubClassing sub;
		CMySubClassing subParent;

	public:
		CMyControl				(BOOL noTitle=FALSE);
		CMyControl				(HWND hWnd) { *this=hWnd; }
		virtual ~CMyControl		();

		void operator=			(HWND hWnd);
		HWND operator []		(int index);

		BOOL Enable				(BOOL enable);
		void DragAcceptFile		(BOOL drag);

		BOOL SetIcon			(long idIcon);

		BOOL ShowWindow			(BOOL isShow);
		BOOL DestroyWindow		();
		BOOL SetForegroundWindow();
		HWND SetActiveWindow	();
		HWND SetFocus			() { return ::SetFocus(GetHWND()); }
		BOOL IsFocus			() { return GetFocus()==GetHWND(); }
		BOOL IsToolWindow		();

		HWND GetParent			();
		HINSTANCE GethInstance	();
		HWND GetHWND			() { return m_hWndControl; }

		HWND CreateDialog		(long idDialog,DLGPROC callBack,long param=NULL);
		int ModalDialog			(long idDialog,DLGPROC callBack,long param=NULL);

		BOOL GetWindowRect		(RECT *rect);
		operator HWND			() const { return m_hWndControl; }

		BOOL GetText			(MyString &dest,int idChildControl=0);
		BOOL SetText			(char *dest,int idChildControl=0);

		int	GetDlgCtrlID		();
		int	GetItemHeight		() { return m_itemHeight; }
		void SetItemHeight		(int height) { m_itemHeight = height; }

		BOOL InvalidateRect		(RECT *rect=NULL,BOOL erase=TRUE);
		BOOL GetClientRect		(RECT *rect);
		BOOL SetPos				(int x,int y,HWND hWndOrigine=NULL);
		BOOL SetSize			(int dx,int dy);
		BOOL GetSize			(int *dx,int *dy);
		BOOL GetPos				(int *x,int *y);

		LRESULT SendMessage		(UINT Msg,WPARAM wParam,LPARAM lParam);
		void PostMessage		(UINT Msg,WPARAM wParam,LPARAM lParam);

		DWORD GetStyle			();
		DWORD GetStyleEx		();
		LONG SetStyle			(DWORD dwStyle);
		LONG SetStyle			(DWORD dwStyle,BOOL set);
		LONG SetStyleEx			(DWORD dwStyle);
		LONG SetStyleEx			(DWORD dwStyle,BOOL set);

		void SetTopMost			(BOOL set);

		int MessageBox			(char *text,char *caption,UINT type=0);

		HMENU GetSystemMenu		(BOOL bRevert);
		HWND SetCapture();


};

#endif // !defined(AFX_MYCONTROL_H__EC7EC7AD_A9D6_414E_A3B6_66870A1519B1__INCLUDED_)
