#ifndef INCLUDE_MY_DEBUG_H
#define INCLUDE_MY_DEBUG_H

/* fonctionnement *******************************************
class MyDebug est la partie cliente (qui envoi) du debugeur (cf MyServerDebug)

Ex.:
MyDebug::SendEvent("mon_programme","mon_evenement(%d,%d)",param1,param2);

Protocole client<->serveur:
header "tabName" text
header = {#line,#event}
**************************************************** */

#include <windows.h>
#include <stdio.h>
#include <stdarg.h>
#include "MyString.h"

class MyDebug  
{
	public:
	static HWND hWndServer;

	static BOOL Send(char *message)
	{
		COPYDATASTRUCT cpd;
		cpd.dwData = 0;
		cpd.cbData = (DWORD)strlen(message)+1;
		cpd.lpData = (void *)message;
		return (BOOL)SendMessage(MyDebug::hWndServer, WM_COPYDATA, NULL,(LPARAM)&cpd);
	}

public:
	MyDebug()
	{
		Start();
	}

	~MyDebug()
	{
	}

	static void Start()
	{
		if (!hWndServer)
		{
			FindServer();
		}
	}

	static BOOL FindServer()
	{
		hWndServer = FindWindow(NULL,"DebugServer");
		return hWndServer?TRUE:FALSE;
	}

	static BOOL SendEvent(char *tabName,char *message,...)
	{
		MyString buffer;

		char temp[1024];
		va_list args;
		va_start(args,message);
		vsprintf(temp,message,args);

		buffer<<"#event \""<<tabName<<"\" "<<temp<<"\n";
		return Send(buffer);
	}

	static BOOL SendLine(char *tabName,char *message,...)
	{
		MyString buffer;

		char temp[1024];
		va_list args;
		va_start(args,message);
		vsprintf(temp,message,args);

		buffer<<"#line \""<<tabName<<"\" "<<temp<<"\n";
		return Send(buffer);
	}
};

HWND MyDebug::hWndServer = NULL; // instansiation de la varaible static de class (sinon pb au linkage)

#endif 

