#include <windows.h>
#include "resource.h"
#include <windowsx.h>
#include <commctrl.h> // ne pas oublier la comctl32.lib 
#pragma comment(lib, "comctl32.lib")


#include "MyString.h"
#include "MyTabCtrl.h"
#include "MyControl.h"
#include "MyRichEdit.h"
#include "MyScroll.h"
#include "MyStatic.h"
#include "MyButton.h"
#include "resizeWin.h"
#include "MyRect.h"
#include "MyDebug.h"
#include "MyWindow.h"
#include "MyRegistry.h"

LRESULT ProcTest(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT ProcOption (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

// *******************************************************************************************

class CParamRepport
{
	public:
		CMyControl window;
		CMyControl windowMain;
		CMyRichEdit repport;
		BOOL viewLast;
		CMyStatic lastLine;
		CMyRect rect;
		CMyTabCtrl *tab;
		MyString tabName;
		int count;

	public:
		
	CParamRepport() 
	{
		viewLast = TRUE;
		count=0;
	}

	void operator= (CParamRepport &source) 
	{
		windowMain = source.windowMain;
		tab = source.tab;
		tabName = source.tabName;
		window = source.window;
		repport = source.repport;
		viewLast = source.viewLast;
		rect = source.rect;
		count = source.count;
	}
};

MyList<CParamRepport> lParamRepport;

// *******************************************************************************************

LRESULT ProcRepport (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static CMySize delta;

	CParamRepport *param = (CParamRepport *)GetWindowLong (hDlg,GWL_USERDATA);

	switch (message)
	{
		case WM_INITDIALOG:	
			param = (CParamRepport *)lParam;
			SetWindowLong (hDlg,GWL_USERDATA,(LONG)lParam);
			param->window = hDlg;
			param->window.GetWindowRect(&param->rect.r);
			param->repport = param->window[IDC_RICHEDIT_REPPORT];
			param->lastLine = param->window[IDC_RICHEDIT_LAST];
			param->viewLast = TRUE;
			param->repport.SetAutoScroll(param->viewLast);
			Button_SetCheck(param->window[IDC_CHECK_VIEWLAST],param->viewLast);
			return TRUE;

		case WM_SIZE:
			GetDeltaWindow(param->window,&param->rect,&delta);
			SetDeltaWindowSize(param->window[IDC_RICHEDIT_REPPORT],delta.dx,delta.dy);
			SetDeltaWindowSize(param->window[IDC_RICHEDIT_LAST],delta.dx,0);
			SetDeltaWindowPos(param->window[IDC_RICHEDIT_LAST],0,delta.dy);
			SetDeltaWindowPos(param->window[IDC_STATIC1],0,delta.dy);
			SetDeltaWindowPos(param->window[IDC_CHECK_VIEWLAST],delta.dx,delta.dy);
			param->window.InvalidateRect();
			return TRUE;

		case WM_COMMAND:
			WPARAM id;
			id = LOWORD(wParam);
			switch (id)
			{		
				case IDCANCEL:
				case IDOK:
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;

				case IDC_CHECK_VIEWLAST:
					param->viewLast = Button_GetCheck(param->window[IDC_CHECK_VIEWLAST]);
					param->repport.SetAutoScroll(param->viewLast);
					return TRUE;
			}
			break;
	}
	return FALSE;
}

// *******************************************************************************************
// Syntax typeEvent "tabName" text

BOOL ViewTabName (char *result,CMyTabCtrl *tab,BOOL isGlobal)
{
	CParamRepport paramRepport,*ptrParamRepport;
	MyString temp,temp2;
	MyString source,tabName,typeEvt,text;
	source=result;
	int debTabName = source.FindLetter(0,TRUE,'\"');
	int finTabName = source.FindLetter(debTabName+1,TRUE,'\"');
	if (debTabName!=-1 && finTabName!=-1)
	{
		source.CopyTo(tabName,debTabName+1,finTabName-debTabName-1);
		source.CopyTo(typeEvt,0,debTabName-1);
		source.CopyTo(text,finTabName+2,-1);
	}
	else return FALSE;
	int page = tab->FindPage(tabName);

	if (page==-1)
	{
		lParamRepport+=paramRepport;
		ptrParamRepport = lParamRepport.GetElemPtr();
		ptrParamRepport->tabName = tabName;
		ptrParamRepport->tab = tab;
		ptrParamRepport->windowMain = tab->GetParent();
		HWND hWnd = tab->CreateDialog(IDD_DIALOG_REPORT,(DLGPROC)ProcRepport,(long)ptrParamRepport);
		page = tab->Add(hWnd,tabName);
		tab->SetImage(page,0);
		tab->ShowPage(page);
	}
	else
	{
		lParamRepport.GoIndex(first,page);
		ptrParamRepport = lParamRepport.GetElemPtr();
	}
	temp<<clear<<'#'<<ptrParamRepport->count++<<" - ";
	ptrParamRepport->repport.InsertText(temp);

	temp = typeEvt;
	if (temp=="#line") 
	{
		ptrParamRepport->repport.SetEffect(FALSE,FALSE,FALSE,RGB(128,128,128));
		ptrParamRepport->repport.InsertText("> ");
	}
	else if (temp=="#event") ptrParamRepport->repport.SetEffect(FALSE,FALSE,FALSE,RGB(0,0,0));
	else ptrParamRepport->repport.SetEffect(FALSE,FALSE,FALSE,RGB(0,255,0));
	ptrParamRepport->repport.ApplyEffect();
	ptrParamRepport->repport.InsertText(text);
	ptrParamRepport->lastLine.SetText(text);
	if (page!=tab->GetCurPage()) tab->Highlight(page,TRUE);
	temp2<<clear<<typeEvt<<" \"Global\" ("<<tabName<<") "<<text;

	if (!isGlobal) ViewTabName(temp2,tab,TRUE);
	return TRUE;
}

// ***************************************************************************************
#define IDC_BUTTON_CLEAR	1974
#define IDC_CHECK_PAUSE		1973 //(belle anne)
#define IDC_BUTTON_TEST		1972
#define IDC_BUTTON_OPTION	1975
#define IDC_CHECK_TOPMOST	1971

BOOL isPaused = FALSE;
BOOL isAutoView = FALSE;
BOOL isFlash = TRUE;
BOOL isTopMost = FALSE;
int deltaX,deltaY; // taille de la fenetre

LRESULT ProcMain(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static CMyWindow window;
	static CMyControl control;
	static CMyTabCtrl tab;
	static CMySize delta;
	static CMyRect rectWindow;

	switch (message)
	{
		case WM_INITDIALOG:	
			{
				MyRegistry reg(TRUE);
				reg="HKCU\\Software\\MyDebugServer";
				if (!reg.GetValue("Paused",&isPaused)) isPaused = FALSE;
				if (!reg.GetValue("Flash",&isFlash)) isFlash = TRUE;
				if (!reg.GetValue("AutoView",&isAutoView)) isAutoView = TRUE;
				if (!reg.GetValue("TopMost",&isTopMost)) isTopMost = FALSE;
				if (!reg.GetValue("deltaX",&deltaX)) deltaX = 300;
				if (!reg.GetValue("deltaY",&deltaY)) deltaY = 200;
			}
			MyDebug::Start();
			window = hDlg;
			window.SetIcon(IDI_MAIN);
			window.AddTitleCheck(IDC_CHECK_TOPMOST,20,14,IDB_TICK_ON,IDB_TICK_OFF);
			window.AddTitleButton(IDC_BUTTON_OPTION,11,14,IDB_OPTION_ON,IDB_OPTION_OFF);
			window.AddTitleButton(IDC_BUTTON_TEST,11,14,IDB_TEST_ON,IDB_TEST_OFF);
			window.AddTitleCheck(IDC_CHECK_PAUSE,11,14,IDB_PAUSE_ON,IDB_PAUSE_OFF);
			window.AddTitleButton(IDC_BUTTON_CLEAR,11,14,IDB_CLEAR_ON,IDB_CLEAR_OFF);

			tab = window[IDC_TAB_DEBUG];
			tab.imageList.Init(12,11,window.GethInstance());
			tab.imageList.AddImage(IDB_CLOSE_OFF);
			tab.imageList.AddImage(IDB_CLOSE_ON);
			tab.iconIsButton = TRUE;

			window.SetTitleCheckState(IDC_CHECK_TOPMOST,isTopMost);
			window.SetTitleCheckState(IDC_CHECK_PAUSE,isPaused);

			window.GetWindowRect(&rectWindow.r);		
			SetWindowPos(window,NULL,0,0,deltaX,deltaY,SWP_NOMOVE|SWP_NOZORDER|SWP_NOREDRAW|SWP_NOACTIVATE|SWP_NOCOPYBITS|SWP_NOSENDCHANGING);
			return TRUE;

		case WM_SIZE:
			GetDeltaWindow(window,&rectWindow,&delta);
			SetDeltaWindowSize(tab,delta.dx,delta.dy);
			for (int i=0;i<tab.GetNbPage();i++) 
				SetDeltaWindowSize(tab[i],delta.dx,delta.dy);
			window.InvalidateRect();
			return TRUE;

		case WM_COMMAND:
			WPARAM id;
			id = LOWORD(wParam);
			switch (id)
			{	
				case IDC_CHECK_TOPMOST:
					isTopMost = (BOOL)lParam;
					window.SetTopMost(isTopMost);
					return TRUE;

				case IDC_CHECK_PAUSE:
					isPaused=(BOOL)lParam;
					return TRUE;

				case IDC_BUTTON_TEST:
					ShowWindow(window.CreateDialog(IDD_DIALOG_TEST,(DLGPROC)ProcTest),SW_SHOW);
					return TRUE;			

				case IDC_BUTTON_OPTION:
					ShowWindow(window.CreateDialog(IDD_DIALOG_OPTION,(DLGPROC)ProcOption),SW_SHOW);
					return TRUE;			

				case IDC_BUTTON_CLEAR:
					tab.Reset();
					lParamRepport.SuprAll();
					return TRUE;

				case IDCANCEL:
				case IDOK:
					{
						MyRegistry reg(TRUE);
						reg="HKCU\\Software\\MyDebugServer";
						reg.SetValue("Paused",isPaused);
						reg.SetValue("Flash",isFlash);
						reg.SetValue("AutoView",isAutoView);
						reg.SetValue("TopMost",isTopMost);
						deltaX=rectWindow.DeltaX();
						deltaY=rectWindow.DeltaY();
						reg.SetValue("deltaX",deltaX);
						reg.SetValue("deltaY",deltaY);
					}
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;

				case IDC_TAB_DEBUG:
					{
						ENotifyTabCtrl eNotify = (ENotifyTabCtrl) lParam;
						switch(eNotify)
						{
							case TabCtrlClickRightOnIcon:
								//if (window.MessageBox("Close this forder ?","Folder ask",MB_YESNO)==IDYES)
								{
									lParamRepport.Supr(tab.GetCurPage());
									tab.Sup(tab.GetCurPage());
								}
								break;
								
							case TabCtrlChange:
								tab.Highlight(tab.GetCurPage(),FALSE);
								break;
						}
					}
					return TRUE;
			}
			break;

		case WM_COPYDATA:
			{
				PCOPYDATASTRUCT dataStruct = (PCOPYDATASTRUCT) lParam;
				char *result = (char *)dataStruct->lpData;
				if (!isPaused) 
				{
					ViewTabName (result,&tab,FALSE);

					// flash la fenetre
					if (isFlash)
					{
						FLASHWINFO fi;
						fi.cbSize=sizeof(fi);
						fi.uCount=1;
						fi.dwFlags=FLASHW_TRAY;
						fi.hwnd=window;
						fi.dwTimeout=0;
						FlashWindowEx(&fi);
					}

					if (GetForegroundWindow()!=window)
					{
						if (isAutoView) SetForegroundWindow(window);
					}
				}
			}
			break;
	}
	return FALSE;
}

// *******************************************************************************************

LRESULT ProcTest(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static MyString temp,temp2;
	CMyControl window;
	window = hDlg;

	switch (message)
	{
		case WM_INITDIALOG:	
			return TRUE;

		case WM_COMMAND:
			WPARAM id;
			id = LOWORD(wParam);
			switch (id)
			{	
				case IDCANCEL:
				case IDOK:
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;

				case IDC_BUTTON_SENDEVENT:
					window.GetText(temp,IDC_RICHEDIT_TABNAME);
					window.GetText(temp2,IDC_RICHEDIT_EVENT);
					MyDebug::SendEvent(temp,temp2);
					return TRUE;

				case IDC_BUTTON_SENDLINE:
					window.GetText(temp,IDC_RICHEDIT_TABNAME);
					window.GetText(temp2,IDC_RICHEDIT_LINE);
					MyDebug::SendLine(temp,temp2);
					return TRUE;
			}
			break;
	}
	return FALSE;
}

// *******************************************************************************************

LRESULT ProcOption (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	CMyControl control;

	switch (message)
	{
	case WM_INITDIALOG:	
		Button_SetCheck(GetDlgItem(hDlg,IDC_CHECK_FLASH),isFlash);
		Button_SetCheck(GetDlgItem(hDlg,IDC_CHECK_AUTOVIEW),isAutoView);
		return TRUE;

	case WM_COMMAND:
		WPARAM id;
		id = LOWORD(wParam);
		switch (id)
		{	
		case IDC_BUTTON_APPLY:
			isFlash = Button_GetCheck(GetDlgItem(hDlg,IDC_CHECK_FLASH));
			isAutoView = Button_GetCheck(GetDlgItem(hDlg,IDC_CHECK_AUTOVIEW));
		case IDC_BUTTON_CANCEL:
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
	}
	return FALSE;
}

// *******************************************************************************************

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	LoadLibrary("riched32.dll");
	InitCommonControls();
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG_MAIN),NULL,(DLGPROC)ProcMain);  
	return 0;
}