#if !defined(AFX_MYIMAGELIST_H__713315A7_7538_4002_984C_B3B4E98A53CD__INCLUDED_)
#define AFX_MYIMAGELIST_H__713315A7_7538_4002_984C_B3B4E98A53CD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windowsx.h>
#include <commctrl.h>
class CMyImageList  
{
	private:
		HIMAGELIST himl;
		int m_dx;
		int m_dy;
		HINSTANCE m_hInstance;

	public:
		CMyImageList()
		{
			m_dx = 0;
			m_dy = 0;
			m_hInstance = NULL;
			himl = NULL;
		}
		
		CMyImageList(int dx, int dy,HINSTANCE hInstance)
		{
			Init(dx, dy,hInstance);
		}

		void Init(int dx, int dy,HINSTANCE hInstance)
		{
			m_hInstance = hInstance;
			m_dx = dx;
			m_dy = dy;
			himl = Create(dx,dy,FALSE,2,0);
		}

		virtual ~CMyImageList()
		{
			Destroy();
		}

		char operator [] (int num)
		{
		}
		
		operator HIMAGELIST() const
		{
			return himl;
		}

		HIMAGELIST Create(int cx, int cy, UINT flags, int cInitial, int cGrow)
		{
			return ImageList_Create(cx, cy, flags, cInitial, cGrow);
		}

		BOOL Destroy()
		{
			return ImageList_Destroy(himl);
		}

		int GetImageCount()
		{
			return ImageList_GetImageCount(himl);
		}

		BOOL SetImageCount(UINT uNewCount)
		{
			return ImageList_SetImageCount(himl,uNewCount);
		}

		int Add(HBITMAP hbmImage, HBITMAP hbmMask)
		{
			return ImageList_Add(himl, hbmImage, hbmMask);
		}

		int AddImage (int idImage)
		{
			HBITMAP hBit = ::LoadBitmap(m_hInstance, MAKEINTRESOURCE(idImage));
			if (!hBit) return FALSE;
			return Add(hBit,NULL);
		}

		int AddIcon (int idIcon)
		{
			HICON hbmp = (HICON) ::LoadImage(m_hInstance,MAKEINTRESOURCE(idIcon),IMAGE_ICON,m_dx,m_dy,0);
			if (!hbmp) return FALSE;
			return Add((HBITMAP)hbmp,NULL);
		}

		int ReplaceIcon(int i, HICON hicon)
		{
			return ImageList_ReplaceIcon(himl, i, hicon);
		}

		COLORREF SetBkColor(COLORREF clrBk)
		{
			return ImageList_SetBkColor(himl, clrBk);
		}

		COLORREF GetBkColor()
		{
			return ImageList_GetBkColor(himl);
		}

		BOOL SetOverlayImage(int iImage, int iOverlay)
		{
			return ImageList_SetOverlayImage(himl, iImage, iOverlay);
		}

		BOOL Draw(int i, HDC hdcDst, int x, int y, UINT fStyle)
		{
			return ImageList_Draw(himl, i, hdcDst, x, y, fStyle);
		}

		BOOL Replace(int i, HBITMAP hbmImage, HBITMAP hbmMask)
		{
			return ImageList_Replace(himl, i, hbmImage, hbmMask);
		}

		int AddMasked(HBITMAP hbmImage, COLORREF crMask)
		{
			return ImageList_AddMasked(himl, hbmImage, crMask);
		}

		BOOL DrawEx(int i, HDC hdcDst, int x, int y, int dx, int dy, COLORREF rgbBk, COLORREF rgbFg, UINT fStyle)
		{
			return ImageList_DrawEx(himl, i, hdcDst, x, y, dx, dy, rgbBk, rgbFg, fStyle);
		}

		BOOL DrawIndirect(IMAGELISTDRAWPARAMS* pimldp)
		{
			return ImageList_DrawIndirect(pimldp);
		}

		BOOL Remove(int i)
		{
			return ImageList_Remove(himl, i);
		}

		HICON GetIcon(int i, UINT flags)
		{
			return ImageList_GetIcon(himl, i, flags);
		}

		HIMAGELIST LoadImage(HINSTANCE hi, LPCSTR lpbmp, int cx, int cGrow, COLORREF crMask, UINT uType, UINT uFlags)
		{
			return ImageList_LoadImage(hi, lpbmp, cx, cGrow, crMask, uType, uFlags);
		}

		BOOL Copy(int iDst, HIMAGELIST himlSrc, int iSrc, UINT uFlags)
		{
			return ImageList_Copy(himl, iDst, himlSrc, iSrc, uFlags);
		}

		BOOL BeginDrag(int iTrack, int dxHotspot, int dyHotspot)
		{
			return ImageList_BeginDrag(himl, iTrack, dxHotspot, dyHotspot);
		}

		void EndDrag()
		{
			ImageList_EndDrag();
		}

		BOOL DragEnter(HWND hwndLock, int x, int y)
		{
			return ImageList_DragEnter(hwndLock, x, y);
		}

		BOOL DragLeave(HWND hwndLock)
		{
			return ImageList_DragLeave(hwndLock);
		}

		BOOL DragMove(int x, int y)
		{
			return ImageList_DragMove(x, y);
		}

		BOOL SetDragCursorImage(int iDrag, int dxHotspot, int dyHotspot)
		{
			return ImageList_SetDragCursorImage(himl, iDrag, dxHotspot, dyHotspot);
		}

		BOOL DragShowNolock(BOOL fShow)
		{
			return ImageList_DragShowNolock(fShow);
		}

		HIMAGELIST GetDragImage(POINT FAR* ppt,POINT FAR* pptHotspot)
		{
			return ImageList_GetDragImage(ppt, pptHotspot);
		}
/*
		HIMAGELIST Read(LPSTREAM pstm)
		{
			return ImageList_Read(pstm);
		}

		BOOL Write(LPSTREAM pstm)
		{
			return ImageList_Write(pstm);
		}
*/
		BOOL SetIconSize(int cx, int cy)
		{
			return ImageList_SetIconSize(himl, cx, cy);
		}
		
		BOOL GetImageInfo(int i, IMAGEINFO FAR* pImageInfo)
		{
			return ImageList_GetImageInfo(himl, i, pImageInfo);
		}

		HIMAGELIST Merge(int i1, HIMAGELIST himl2, int i2, int dx, int dy)
		{
			return ImageList_Merge(himl, i1, himl2, i2, dx, dy);
		}
/*
		HIMAGELIST operator=()
		{
			return Duplicate();
		}
*/		
		HIMAGELIST Duplicate()
		{
			return ImageList_Duplicate(himl);
		}

		BOOL RemoveAll()
		{
			return ImageList_RemoveAll(himl);
		}

		HICON ExtractIcon(HINSTANCE hi, int i)
		{
			return ImageList_ExtractIcon(hi, himl, i) ;
		}

		HIMAGELIST LoadBitmap(HINSTANCE hi, LPCSTR lpbmp, int cx, int cGrow, COLORREF crMask)
		{
			return ImageList_LoadBitmap(hi, lpbmp, cx, cGrow, crMask);
		}
};

#endif // !defined(AFX_MYIMAGELIST_H__713315A7_7538_4002_984C_B3B4E98A53CD__INCLUDED_)
