#ifndef INCLUDE_LISTE_GENERIQUE_H
#define INCLUDE_LISTE_GENERIQUE_H
/*
#ifndef BOOL // gestion des cross-platform
	#define BOOL	short
	#define TRUE	1
	#define FALSE	0
#endif
*/

#include <stdio.h>
#include <math.h>

/* **********************************************************************************
	// Ex: liste de int;

	CMyListe <int> listInt;

	int num;
	listInt.AddFirst(12);
	listInt.AddFirst(13);
	listInt += 14;
	listInt.AddAfterCurrent(5);
	listInt.AddBeforCurrent(6);
	listInt.AddFirst(7);

	for (listInt=0;listInt.More();listInt++)
	{
		int last = listInt.GetElem();
		sprintf(temp,"%d",last);
	}
	// ==> 7,12,13,14,6,5
********************************************************************************** */

typedef enum _ETypeStart
{
	current = 1,first,last,befor,next
} ETypeStart; // pour le param1 de GoIndex

#include "MyException.h"

template <class T> class MyList
{
	typedef struct List_
	{
	  T *elem; 							// element de la liste 
	  struct List_ *next,*befor;       // sucesseur 
	  BOOL selfAlloc;					// le ptr doit il etre des aloues a la fin
	} *List, ElemList;

	private:
		List	m_first;
		List	m_last;
		List	m_current;
		int		m_nbElem;
		int		m_numLastElem;
//		int		(* FoncCompare)(T elem1,T elem2);	// fonction de comparaison

	public:
		T *		m_elemNull;

		/* **********************************************************************************
			Init de la liste
		********************************************************************************** */

		MyList ()
		{
			m_first = NULL;
			m_current = NULL;
			m_last = NULL;
			m_nbElem = 0;
			m_numLastElem = -1;
			//FoncCompare = DefaultFoncCompare;
		}

/*
		MyList (int(*_FoncCompare)(T,T))	// fonction de comparaison
		{
			m_first = NULL;
			m_current = NULL;
			m_last = NULL;
			m_nbElem = 0;
			m_numLastElem = -1;

			FoncNew = _FoncNew ? _FoncNew : DefaultFoncNew;
		}
*/
		/* **********************************************************************************
		   liberation d'une liste
		********************************************************************************** */

		~MyList ()
		{
			SuprAll();
		}

		/* **********************************************************************************
			Cree un element de la liste avec comme valuer l'element lui meme alloue et recopi de l'original
		********************************************************************************** */

		List NewElem (T *elem,BOOL selfAlloc)
		{
			List liste = new (ElemList);
			if (!liste) throw MyExceptionMemory("CMyList","NewElem",sizeof(ElemList));
			liste->selfAlloc = selfAlloc;
			if (selfAlloc) 
			{
				liste->elem = new T;
				*liste->elem=*elem; //operator=(T &source) de la class appel, pourais etre aussi le contructeur de copie
			}
			else liste->elem = elem;
			if (!liste->elem) throw MyExceptionMemory("CMyList","NewElem",sizeof(T));
			liste->next=NULL;
			liste->befor=NULL;
			m_numLastElem = -1;
			return liste;
		}

		List NewElem (T *elem) { return NewElem(elem,FALSE); }

		List NewElem (T &elem) { return NewElem(&elem,TRUE); }
/*
			List liste = new (ElemList);
			if (!liste) throw CMyExceptionMemory("CMyList","NewElem",sizeof(ElemList));
			liste->selfAlloc = TRUE;
			liste->elem = new T;
			if (!liste->elem) throw CMyExceptionMemory("CMyList","NewElem",sizeof(T));
			liste->next=NULL;
			liste->befor=NULL;
			*liste->elem=elem; //operator=(T &source) de la class appel, pourais etre aussi le contructeur de copie
			m_numLastElem = -1;
			return liste;
		}
*/
		/* **********************************************************************************
			Efface un elem de list et sa valeur associ
		********************************************************************************** */

		BOOL DelElem (List l)
		{
			if (l == NULL) return FALSE;
			if (l->elem&&l->selfAlloc) delete l->elem;
			delete l;
			m_numLastElem = -1;
			return TRUE;
		}

		/* **********************************************************************************
			Ajout en debut de liste
		********************************************************************************** */

		BOOL AddFirst (T *elem) { return AddFirst(elem,FALSE); }
		BOOL AddFirst (T &elem) { return AddFirst(&elem,TRUE); }
		BOOL AddFirst (T *elem,BOOL selfAlloc)
		{
			List lNew;
			lNew = NewElem (elem,selfAlloc);
			if (lNew == NULL) return FALSE;
			if (m_first == NULL) m_current = m_first = m_last = lNew;  
			else 
			{
				m_first->befor = lNew;
				lNew->next = m_first;
				m_first = lNew;
				m_current = lNew;
			}
			m_nbElem ++;
			return TRUE;
		}


		/* **********************************************************************************
			Ajout en fin de liste
		********************************************************************************** */

		BOOL AddLast (T *elem) { return AddLast(elem,FALSE); }
		BOOL AddLast (T &elem) { return AddLast(&elem,TRUE); }
		BOOL AddLast (T *elem,BOOL selfAlloc)
		{
			List lNew;
			lNew = NewElem (elem,selfAlloc);
			if (lNew == NULL) return FALSE;
			if (m_last == NULL) m_current = m_first = m_last = lNew;  
			else 
			{
				m_last->next = lNew;
				lNew->befor = m_last;
				m_last = lNew;
				m_current = lNew;
			}
			m_nbElem ++;
			return TRUE;
		}

		/* **********************************************************************************
			Ajourt avant le current
		********************************************************************************** */

		BOOL AddBeforCurrent (T *elem) { return AddBeforCurrent(elem,FALSE); }
		BOOL AddBeforCurrent (T &elem) { return AddBeforCurrent(&elem,TRUE); }
		BOOL AddBeforCurrent (T *elem,BOOL selfAlloc)
		{
			List lNew;
			lNew = NewElem (elem,selfAlloc);
			if (lNew == NULL) return FALSE;
			if (m_current == NULL)  
			{
				if (m_first == NULL && m_last == NULL) m_first = m_last = m_current = lNew;
				else return FALSE;
			}
			else 
			{
				if (m_current == m_first)
				{
					m_first->befor = lNew;
					lNew->next = m_first;
					m_first = m_current = lNew;
				}
				else
				{
					lNew->befor = m_current->befor;
					m_current->befor->next = lNew;
					m_current->befor = lNew;
					lNew->next = m_current;
					m_current = lNew;
				}
			}
			m_nbElem ++;
			return TRUE;
		}

		/* **********************************************************************************
			Ajout pares le current
		********************************************************************************** */

		BOOL AddAfterCurrent (T *elem) { return AddAfterCurrent(elem,FALSE); }
		BOOL AddAfterCurrent (T &elem) { return AddAfterCurrent(&elem,TRUE); }
		BOOL AddAfterCurrent (T *elem,BOOL selfAlloc)
		{
			List lNew;
			lNew = NewElem (elem,selfAlloc);
			if (lNew == NULL) return FALSE;
			if (m_current == NULL) 
			{
				if (m_first == NULL && m_last == NULL) m_first = m_last = m_current = lNew;
				else return FALSE;
			}
			else 
			{
				if (m_current == m_last)
				{
					m_last->next = lNew;
					lNew->befor  = m_last;
					m_last = m_current = lNew;
				}
				else
				{
					lNew->next = m_current->next;
					m_current->next->befor = lNew;
					m_current->next = lNew;
					lNew->befor = m_current;
					m_current = lNew;
				}
			}
			m_nbElem ++;
			return TRUE;
		}

		/* **********************************************************************************
		   Supression d'un element dans la liste en tete
		********************************************************************************** */

		BOOL SuprFirst ()
		{
			if (m_first == NULL) return FALSE;
			List temp;

			temp = m_first->next;
			DelElem(m_first);
			if (temp == NULL) m_current = m_first = m_last = NULL;
			else
			{
				temp->befor = NULL;
				m_current = m_first = temp;
			}
			m_nbElem --;
			return TRUE;
		}

		/* **********************************************************************************
		   Supression d'un element dans la liste en fin
		********************************************************************************** */

		BOOL SuprLast ()
		{
			if (m_last == NULL) return FALSE;
			List temp;

			temp = m_last->befor;
			DelElem(m_last);
			if (temp == NULL) m_current = m_first = m_last = NULL;
			else
			{
				temp->next = NULL;
				m_current = m_last = temp;
			}
			m_nbElem --;
			return TRUE;		
		}

		/* **********************************************************************************
		   Supression d'un element dans la liste courante
		********************************************************************************** */

		BOOL SuprCurrent ()
		{
			if (m_current == NULL) return FALSE;
			List lNext,lBefor,lOld;

			lNext = m_current->next;
			lBefor = m_current->befor;
			lOld = m_current;

			if (lBefor == NULL && lNext == NULL)
			{
				m_first = m_last = m_current = NULL;	
			}
			else
			{
				if (lBefor != NULL) 
				{
					lBefor->next=lNext;
					if (lNext != NULL) 
					{
						lNext->befor = lBefor;
						m_current = lNext;
					}
					else m_last = m_current = lBefor;
				}
				else 
				{
					m_first = lNext;
					lNext->befor = NULL;
				}
			}
			DelElem(lOld);
			m_nbElem --;
			m_current = NULL;
			return TRUE;
		}

		/* **********************************************************************************
		   Supression de tout les elements
		********************************************************************************** */

		BOOL SuprAll ()
		{
			List temp;
			for (GoFirst();More();m_current = temp) 
			{
				temp = m_current->next;
				DelElem(m_current);
			}
			m_current = NULL;
			m_first = NULL;
			m_last = NULL;
			m_nbElem = 0;
			return TRUE;
		}

		/* **********************************************************************************
		   Supression a une index donne
		********************************************************************************** */

		BOOL Supr (int index)
		{
			if (!GoIndex(first,index)) return FALSE;
			return SuprCurrent();
		}

		/* **********************************************************************************
		   Compte le nb d'element dans la liste
		********************************************************************************** */
  
		int GetNbElem()
		{
			return m_nbElem;
		}

		/* **********************************************************************************
			Ajout et retourne un element vide
		********************************************************************************** */

		T * GetNewElem()
		{
			T elem;
			AddLast(elem);
			return GetElemPtr();
		}

		/* **********************************************************************************
		   Donne l'index de l'element courrent (si possible) sinon donne -1
		********************************************************************************** */

		int GetIndex()
		{
			return m_numLastElem;
		}

		/* **********************************************************************************
			Va apres
		********************************************************************************** */

		BOOL GoNext ()
		{
			if (m_current != NULL) m_current = m_current->next; 
			if (m_current != NULL)
			{ 
				m_numLastElem = m_numLastElem == -1 ? -1 : m_numLastElem+1;
				return TRUE ;
			}
			else 
			{
				m_numLastElem = -1;
				return FALSE;
			}
		}

		/* **********************************************************************************
			Va avant
		********************************************************************************** */

		BOOL GoBefor ()
		{
			if (m_current != NULL) m_current = m_current->befor;
			if (m_current != NULL) 
			{
				m_numLastElem = m_numLastElem == -1 ? -1 : m_numLastElem-1;
				return TRUE;
			} 
			else 
			{
				m_numLastElem = -1;
				return FALSE;
			}
		}

		/* **********************************************************************************
			Va au debut
		********************************************************************************** */

		BOOL GoFirst ()
		{
			m_current = m_first;
			m_numLastElem = m_current != NULL ? 0 : -1;
			return m_current != NULL ? TRUE : FALSE;				
		}


		/* **********************************************************************************
			Va depuis curent,first,last,befor,next deplace de nb infos
		********************************************************************************** */

		BOOL GoIndex (ETypeStart start,int nb)
		{
			BOOL isUp;
			isUp = nb<0 ? FALSE : TRUE ; 
			//char temp[128];
			//sprintf(temp,"isUp: %d @nb:%d\n",isUp,nb);
			//OutputDebugString(temp);

			nb = labs(nb);

			//sprintf(temp,"nb:%d\n",nb);
			//OutputDebugString(temp);

			switch (start)
			{
				case current: break;
				case first: 
					if (m_numLastElem != -1) 
					{
						nb = m_numLastElem-nb; 
						isUp = nb<=0;
						nb = labs(nb);
					}
					else 
					{
						isUp = TRUE;  
						GoFirst(); 
					}
					break;
				case last:
					if (m_numLastElem != -1) 
					{
						nb = m_nbElem-m_numLastElem-nb; 
						isUp = nb>=0;
						nb = labs(nb);
					}
					else 
					{
						isUp = FALSE;  
						GoLast(); 
					}
					break;
				case befor: isUp = FALSE; break;
				case next:  isUp = TRUE;  break;
				default:
					return FALSE;
			}
			for (int i=0;i<nb;i++)
			{
				if (More())
				{
					if (isUp) GoNext();
					else GoBefor();
				} else return FALSE;
			}
			return TRUE;
		}
	
		/* **********************************************************************************
			Va a la fin
		********************************************************************************** */

		BOOL GoLast ()
		{
			m_current = m_last;
			m_numLastElem = m_current != NULL ? m_nbElem -1 : -1;
			return m_current ? TRUE : FALSE;
		}

		/* **********************************************************************************
			Donne un ptr sur l'element de la liste
			Ex.: 
			CMyList<int> lInt; 
			lInt+=12;
			lInt+=13;
			int res = (int)lInt;
			int *ptrRes = (int *)lInt;
		********************************************************************************** */

		//inline operator T() const { return GetElem(); } marche pas
		//inline operator T *() const { return GetElemPtr(); }

		T & GetElem (int index=-1)
		{
			if (index!=-1) GoIndex(first,index);
			if (!m_current) return *m_elemNull;
			return *m_current->elem;
		}

		T * GetElemPtr (int index=-1)
		{
			if (index!=-1) GoIndex(first,index);
			if (!m_current) return m_elemNull;
			return m_current->elem;
		}

		/* **********************************************************************************
			enumeration termin ?
		********************************************************************************** */

		BOOL More ()
		{
			return m_current ? TRUE : FALSE;
		}		

		/* **********************************************************************************
			Sauve les donne valide dans un fichier deja ouvert en ecriture 
		********************************************************************************** */

		BOOL SaveData (FILE *fich)
		{
			if (fich == NULL) return FALSE;

			fprintf(fich,"%d",m_nbElem);
			for (GoFirst();More();GoNext())
			{
				if (m_current->elem != NULL)
					if (!fwrite ((void *) m_current->elem,sizeof(T),1,fich)) return FALSE;
			}
			return TRUE;
		}

		/* **********************************************************************************
			Ajoute les donne a partir d'un fichier deja ouvert en lecture
		********************************************************************************** */

		BOOL LoadData (FILE *fich)
		{
			if (fich == NULL) return FALSE;
			
			int i,nb;
			T elem;
			fscanf(fich,"%d",&nb);
			for (i=0;i<nb;i++)
			{
				if (!fread ((void *) &elem,sizeof(T),1,fich))return FALSE;
				if (!AddAfterCurrent(elem)) return FALSE;
			}
			return TRUE;
		}

		/* **********************************************************************************
			Donne la fonction de: { comparaison / new / delete } a appliquer
		********************************************************************************** */

		void SetCompareFunction (int (* fonction)(T * elem1,T * elem2))
		{
			FoncCompare = fonction;
		}
/*
		void SetNewFunction (T * (* fonction)(T * elem))
		{
			FoncNew = fonction;
		}

		void SetDeleteFunction (BOOL (* fonction)(T *elem))
		{
			FoncDelete = fonction;
		}
*/
		/* **********************************************************************************
			list += elem;			==> AddLast
			listDest = listSource;	==> Copy d'une liste dans une autre
			listDest += listSource; ==> Ajout d'une liste dans une autre
			elem = list[12];		==> Acced a l'elem 12 (13) vu que ca commance a 0
			elem = list[-1];		==> Acced au dernier elem
			list = 0;				==> Se place a l'element index 0
			list ++;				==> Se place a l'element suivant;
			list --;				==> Se place a l'element d'avant;
			lisr += 2;				==> Se place a 2 element plus loin
			lisr -= 2;				==> Se place a 2 element avant
		********************************************************************************** */
/*
		void operator += (T &elem)
		{
			AddLast(elem);
		}
*/
		BOOL operator += (T *elem)
		{
			return AddLast(elem);
		}

		BOOL operator += (T elem)
		{
			return AddLast(elem);
		}
	
		BOOL operator = (int index)
		{
			if (index>=0) return GoIndex(first,index);
			else return GoIndex(last,-index+1);
		}

		MyList<T> & operator = (MyList<T> &source)
		{
			SuprAll();
			*this+= source;
			return *this;
		}

		MyList<T> & operator += (MyList<T> &source)
		{
			T elem;
			for (source=0;source.More();source++)
			{
				elem = source.GetElem();
				*this += elem;
			}
			return *this;
		}

		BOOL operator++ (int)
		{
			return GoNext();
		}

		BOOL operator-- (int)
		{
			return GoBefor();
		}

		T * operator () (int num=-1)
		{
			return GetElemPtr(num);
		}

		T & operator [] (int num)
		{
			if (num<0)
			{
				if (!GoIndex(last,-num)) return *m_elemNull;
			}
			else
			{			
				if (!GoIndex(first,num)) return *m_elemNull;
			}
			return GetElem();
		}		
};

template <class T> class MyStack : private MyList<T>
{
public:
	MyStack() : MyList<T>() {}

	BOOL Push(T elem)
	{
		return AddFirst(elem);
	}

	T Pop()
	{
		if (GoLast())
		{
			T elem = GetElem();
			SuprLast();
			return elem;
		}
		return *m_elemNull;
	}

	int GetNbElem()
	{
		return MyList<T>::GetNbElem();
	}
};

// definition des fonctions d'allocation et des alloc par Default

template <class T> int DefaultFoncCompare (T elem1,T elem2)
{
	return memcmp((void *)elem1,(void *)elem2,sizeof(T));
}

/*
template <class T> T * DefaultFoncNew (T *elemSource)
{
	//T * elemDest = elemSource? new T(elemSource) : new T;
	T * elemDest = new T;
	*elemDest = elemSource;
	return elemDest;

	T * elemDest = new T;
	if (elemSource) memcpy((void *)elemDest,(void *)elemSource,sizeof(T));
	return elemDest;
}

template <class T> BOOL DefaultFoncDelete (T * elem)
{
	delete elem;
	return TRUE;
}

// definition des fonctions d'allocation et des alloc dans les MyString

#include "myString.h"

MyString * MyString_FoncNew (MyString *elemSource);
int MyString_FoncCompare (MyString * elem1,MyString * elem2);
#define MyListString(name) MyList<MyString> name(MyString_FoncCompare,MyString_FoncNew,NULL);
*/

#endif
