#if !defined(AFX_MYRICHEDIT_H__C979CD63_7DA1_418E_AD1E_62CA743ECDD5__INCLUDED_)
#define AFX_MYRICHEDIT_H__C979CD63_7DA1_418E_AD1E_62CA743ECDD5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyControl.h"
#include "MyString.h"

typedef enum _ENotifyRichEdit
{
	RichEditNothing, 
	RichEditKeyUp,
	RichEditChange	
} ENotifyRichEdit;

class CMyRichEdit : public CMyControl
{
	private:
		BOOL m_isBold;
		BOOL m_isItalic;
		BOOL m_isUnderline;
		COLORREF m_color;
		int  m_lastKeyUp;
		int  m_controlID;

		BOOL m_isFormatedToFileNane;
		BOOL m_isAutoScroll;
		void Init();
		void ReInit();

	public:
		MyString text;

		CMyRichEdit();
		CMyRichEdit(HWND hWnd);
		CMyRichEdit(HWND hwndMaster,int x,int y,int dx,int dy,int optionalControlID);
		virtual ~CMyRichEdit() {};

		BOOL operator=(HWND hWnd);

		void InsertText(char *text,int pos=-1);
		void RemplaceSelection(char *text);
		void SetSelection(int posBegin,int posEnd);
		void GetSelection(int *posBegin,int *posEnd);
		
		void SetSelectionAll();
		
		void SetEffect(BOOL isBold,BOOL isItalic,BOOL isUnderline,COLORREF color);
		void ApplyEffect();

		void operator=(char *text);
		void Refresh(BOOL setText);

		void SetAutoScroll(BOOL isAutoScroll);

		void FormatedToFileNane();
		void SetFormatedToFileNane(BOOL set) { m_isFormatedToFileNane=set;} 

		int  GetLastKeyUp () { return m_lastKeyUp; }
		int  GetControlID() { return m_controlID; }

		ENotifyRichEdit Notify (LPARAM lParam);

};

#endif // !defined(AFX_MYRICHEDIT_H__C979CD63_7DA1_418E_AD1E_62CA743ECDD5__INCLUDED_)
