#include "stdafx.h"
#include "MySubClassing.h"

// ***********************************************************************************

CMySubClassing::CMySubClassing()
{
	m_isSubclassing = FALSE;
	m_hWndControl = NULL;
}

// ***********************************************************************************

CMySubClassing::~CMySubClassing()
{
	Delete();
}

// ***********************************************************************************

void CMySubClassing::operator=(HWND hWnd)
{
	m_hWndControl = hWnd;
	m_isSubclassing = FALSE;
	Delete();
}

// ***********************************************************************************

void CMySubClassing::Delete()
{
	if (m_isSubclassing)
	{
		SetWindowLong (m_hWndControl,GWL_USERDATA,m_oldData);
		SetWindowLong (m_hWndControl,GWL_WNDPROC,m_oldCallBack);
		m_oldData = m_oldCallBack = 0;
		m_newData = m_newCallBack = 0;
		m_isSubclassing = FALSE;
	}
}

// ***********************************************************************************

void CMySubClassing::Set(WNDPROC newCallBack,long newData)
{
	m_isSubclassing = TRUE;
	m_newData = newData;
	m_oldData = SetWindowLong(m_hWndControl,GWL_USERDATA,m_newData);
	m_newCallBack = (long)newCallBack;
	m_oldCallBack = SetWindowLong(m_hWndControl,GWL_WNDPROC,m_newCallBack);
}

// ***********************************************************************************

LRESULT CMySubClassing::CallWindowProc (UINT message, WPARAM wParam, LPARAM lParam)
{
	SetWindowLong (m_hWndControl,GWL_USERDATA,m_oldData);
	LONG newCallBack = SetWindowLong (m_hWndControl,GWL_WNDPROC,m_oldCallBack);
	LONG res = ::CallWindowProc((WNDPROC)m_oldCallBack,m_hWndControl,message,wParam,lParam);
	m_oldData = SetWindowLong (m_hWndControl,GWL_USERDATA,m_newData);
	m_oldCallBack = SetWindowLong (m_hWndControl,GWL_WNDPROC,newCallBack);
	return res;
}

// ***********************************************************************************
