#include <windows.h>
#include "stdafx.h"
#include <stdio.h>
#include "resizeWin.h"
#include "MyRect.h"

// **************************************************************************************

BOOL GetDeltaWindow(HWND hWndParent,CMyRect *oldRect,CMySize *size)
{
	CMyRect newRect;

	GetWindowRect(hWndParent,&newRect.r);
	size->dx = newRect.DeltaX() - oldRect->DeltaX();
	size->dy = newRect.DeltaY() - oldRect->DeltaY();

	*oldRect = newRect;
	return TRUE;
}

// **************************************************************************************

BOOL SetDeltaWindowSize(HWND hWndControl,int deltaX,int deltaY)
{
	CMyRect rect;

	GetWindowRect(hWndControl,&rect.r);

	SetWindowPos(hWndControl,NULL,0,0,
		rect.DeltaX()+deltaX,
		rect.DeltaY()+deltaY,
		SWP_NOMOVE|SWP_NOZORDER|SWP_NOREDRAW|SWP_NOACTIVATE|SWP_NOCOPYBITS|SWP_NOSENDCHANGING);

	return TRUE;
}

// **************************************************************************************

BOOL SetDeltaWindowPos(HWND hWndControl,int deltaX,int deltaY)
{
	POINT point;
	CMyRect rect;
	GetWindowRect(hWndControl,&rect.r);
	point.x=rect.r.left;
	point.y=rect.r.top;
	HWND hWndParent = GetParent(hWndControl);
	ScreenToClient(hWndParent,&point);
	SetWindowPos(hWndControl,NULL,
		point.x+deltaX,
		point.y+deltaY,
		0,0,SWP_NOSIZE|SWP_NOZORDER|SWP_NOREDRAW|SWP_NOACTIVATE|SWP_NOCOPYBITS|SWP_NOSENDCHANGING);	

	return TRUE;
}